unit qe1;
interface
uses
  sp_Lib_Delphi,

  ShellAPI,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Spin, ComCtrls, Db, DBTables, Grids, DBGrids;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Panel1: TPanel;
    Panel4: TPanel;
    GroupBox1: TGroupBox;
    Panel6: TPanel;
    SpeedButton3: TSpeedButton;
    Memo1: TMemo;
    Splitter1: TSplitter;
    GroupBox2: TGroupBox;
    Query1: TQuery;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel5: TPanel;
    SpeedButton2: TSpeedButton;
    Splitter2: TSplitter;
    GroupBox3: TGroupBox;
    RE_HTML: TRichEdit;
    Panel3: TPanel;
    SpeedButton1: TSpeedButton;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    MainDir : string;
  end;

var
  Form1: TForm1;


// Alias BDE-5 ()
function CreateStandardAlias(NrAlwaysCreate: Boolean; NameAlias, Path, DefDrv : String) : Boolean;

//   Q   HTML-
function Query_CopyToHTML(Q : TQuery;
                          SelNameFields : TStrings;
                          Head : string;
                          AlignTable,BorderTable,SizeFontTopHead : integer;
                          ListOut : TStrings) : integer;



implementation

{$R *.DFM}

Const
  MyAlias = 'Query_to_HTML';

procedure TForm1.FormCreate(Sender: TObject);
begin
  MainDir := ExtractFilePath(ParamStr(0));

  Memo1.Lines.Clear;

  CreateStandardAlias(true,MyAlias,MainDir,'');
  Query1.Close;
  Query1.DatabaseName:=MyAlias;

  Memo1.Lines.Add('SELECT *');
  Memo1.Lines.Add('FROM '+#39+'SC12.DBF'+#39);


end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=true;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
//
begin
  if Query1.Active then begin
     //     HTML-
     Query_CopyToHTML(Query1,
                      NIL,
                      '  TQuery  HTML (http://doc-prg.narod.ru/art_00904/art_00904.htm)',
                      0,1,3,
                      RE_HTML.Lines);
  end
  else begin
     ShowMessage('    ...');
  end;
end;


procedure TForm1.SpeedButton3Click(Sender: TObject);
//  
begin
  Query1.Close;
  Query1.SQL.Clear;
  Query1.SQL.Assign(Memo1.Lines);
  Query1.Open;
end;



procedure TForm1.SpeedButton1Click(Sender: TObject);
Var
  Sx : string;
begin
  if SaveDialog1.Execute then begin
     Sx:=SaveDialog1.FileName;
     RE_HTML.Lines.SaveToFile(Sx);
     if ShellExecute(Handle, 'open', PCHAR(Sx) , nil, nil, sw_Show)<=32 then begin
        ShowMessage('    : '+Sx);
     end;
  end;
end;



//*********************************************
//*********************************************
//*********************************************

function Create_TopHTML(Title,Content,HTML_Cyr,BkColor,BkColorFileName : string) : string;
//  HTML-
//Title,Content -  .  
//HTML_Cyr -   
//BkColor -   ( <body>) 
//BkColorFileName -  .,   ( <body>) 
//   : BkColor  BkColorFileName,  BkColorFileName 
//  ,   HTML-
begin
  BkColorFileName:=Trim(BkColorFileName);
  BkColor:=Trim(BkColor);
  Title:=Trim(Title);
  Content:=Trim(Content);
  HTML_Cyr:=Trim(HTML_Cyr);
  if length(HTML_Cyr)<=0 then HTML_Cyr:='windows-1251';
  Result:='';
  Result:=Result+'<html>';
  Result:=Result+'<meta http-equiv="Content-Type"';
  Result:=Result+'content="text/html; charset='+HTML_Cyr+'">';
  Result:=Result+'<meta name="GENERATOR" content="'+Content+'">';
  Result:=Result+'<title>'+Title+'</title>';
  Result:=Result+'</head>';
  if Length(BkColorFileName)>0 then begin
     Result:=Result+'<body background="'+BkColorFileName+'" bgproperties="fixed" ';
     Result:=Result+'bgcolor="'+BkColor+'"'+'>';
  end
  else begin
     Result:=Result+'<body bgcolor="'+BkColor+'"'+'>';
  end;
end;

function Create_BottomHTML : string;
//   HTML-
//  ,    HTML-
begin
  Result:='';
  Result:=Result+'</body>';
  Result:=Result+'</html>';
end;


function Create_TopFontHTML(sFaceFont,sColorFont,sSizeFont : string;
                            IsBold,IsItalic,IsUnderline : Boolean) : string;
//    
//sFaceFont -  
//sColorFont -  
//sSizeFont -  
//IsBold -  TRUE,  " "
//IsItalic -  TRUE,  " "
//IsUnderline -  TRUE,  " "
//   
begin
  sFaceFont:=Trim(sFaceFont);
  sColorFont:=Trim(sColorFont);
  sSizeFont:=Trim(sSizeFont);
  Result:='';
  Result:=Result+'<FONT ';
  if Length(sColorFont)>0 then Result:=Result+'COLOR="'+sColorFont+'"';
  if Length(sSizeFont)>0 then Result:=Result+' size="'+sSizeFont+'"';
  if Length(sFaceFont)>0 then Result:=Result+' face="'+sFaceFont+'"';
  Result:=Result+'>';
  if IsBold then begin
     Result:=Result+'<strong>';
  end;
  if IsItalic then begin
     Result:=Result+'<em>';
  end;
  if IsUnderline then begin
     Result:=Result+'<u>';
  end;
end;

function Create_BottomFontHTML(IsBold,IsItalic,IsUnderline : Boolean) : string;
//    
//IsBold -  TRUE,   " "
//IsItalic -  TRUE,   " "
//IsUnderline -  TRUE,   " "
begin
  Result:='';
  if IsUnderline then begin
     Result:=Result+'</u>';
  end;
  if IsItalic then begin
     Result:=Result+'</em>';
  end;
  if IsBold then begin
     Result:=Result+'</strong>';
  end;
  Result:=Result+'</FONT>';
end;


function Create_EmptyStringForHTML : string;
//    HTML-
begin
 Result:='<p>&nbsp;</p>';
end;


function Create_StringForHTML(sInfo,
                              sFaceFont,sColorFont,sSizeFont : string;
                              Align : integer;
                              IsBold,IsItalic,IsUnderline : Boolean) : string;
//    HTML-
//sInfo -   ( )
//sFaceFont -  
//sColorFont -  
//sSizeFont -  
//IsBold -  TRUE,  " "
//IsItalic -  TRUE,  " "
//IsUnderline -  TRUE,  " "
//Align -  
//   
Var
  Sx : string;
begin
  Sx:='';
  Result:='';
  if Length(sInfo)<=0 then sInfo:='&nbsp;';
  if Align<0 then begin
     Result:=Result+'<p>';
  end
  else begin
     if Align=0 then begin
        Result:=Result+'<p align="center">';
     end
     else begin
        Result:=Result+'<p align="right">';
     end;
  end;
  Result:=Result+Create_TopFontHTML(sFaceFont,sColorFont,sSizeFont,IsBold,IsItalic,IsUnderline);
  Result:=Result+sInfo;
  Result:=Result+Create_BottomFontHTML(IsBold,IsItalic,IsUnderline);
  Result:=Result+'</p>';
end;


function Create_TopTable(align, border : integer) : string;
//    HTML-
//   
begin
 Result:='';
 if align<0 then begin
   Result:=Result+'<div align="left">';
 end;
 if align=0 then begin
   Result:=Result+'<div align="center"><center>';
 end;
 if align>0 then begin
   Result:=Result+'<div align="right">';
 end;
 Result:=Result+'<table border="'+IntToStr(border)+'" cellpadding="0" cellspacing="0">';
end;


function Create_BottomTable(align : integer) : string;
//      HTML-
//   
begin
 Result:='';
 if align=0 then begin
    Result:='</table></center></div>';
 end
 else begin
    Result:='</table></div>';
 end;
end;


function Create_LineTableHTML(ListData : TStrings) : string;
{
   HTML-
ListData -  
  -  
1 - align  (-1,0,1)
2 - strong (0,1)
3 - italic (0,1)
4 -  (0,1)
5 -  (0,1)
6 - 
7 - 
8 -  ( )
  -  | ( )
//   
}
Var
  NameZakl, //
  NameRef,  //
  Sx : string;
  YesZakl,YesRef,strong,italic,
  align, i : integer;
begin
 Result:='';
 if ListData<>NIL then begin
    if ListData.Count>0 then begin

       //   
       Result:=Result+'<tr>';

       i:=-1;
       while i<(ListData.Count-1) do
        begin
         i:=i+1;

         //-----------------------------------------
         //  
         align    := sp_StrToInt(sp_GetWordFromString('|',ListData[i],1),0);
         strong   := sp_StrToInt(sp_GetWordFromString('|',ListData[i],2),0);
         italic   := sp_StrToInt(sp_GetWordFromString('|',ListData[i],3),0);
         //-----------------------------------------

         //-----------------------------------------
         //     
         YesRef   := sp_StrToInt(sp_GetWordFromString('|',ListData[i],4),0);
         YesZakl  := sp_StrToInt(sp_GetWordFromString('|',ListData[i],5),0);
         NameRef  := Trim(sp_GetWordFromString('|',ListData[i],6));
         NameZakl := Trim(sp_GetWordFromString('|',ListData[i],7));
         //-----------------------------------------

         //-----------------------------------------
         //   
         Sx:=Trim(sp_GetWordFromString('|',ListData[i],8));
         if Length(NameRef)<=0 then NameRef:=Sx;
         if Length(NameRef)<=0 then YesRef:=0;
         if Length(NameZakl)<=0 then YesZakl:=0;
         //-----------------------------------------


         //-----------------------------------------
         //  () 
         if length(Sx)<=0 then begin
            Sx:='&nbsp;';
         end;

         if align<0 then begin
            //    
            Result:=Result+'<td>';
         end
         else begin
            if align=0 then begin
               //    
               Result:=Result+'<td align="center">';
            end
            else begin
               //    
               Result:=Result+'<td align="right">';
            end;
         end;
         if YesRef>0 then begin
            Result:=Result+'<a href="'+NameRef+'"';
            if YesZakl>0 then begin
               Result:=Result+' name="'+NameZakl+'"';
            end;
            Result:=Result+'>';
         end
         else begin
            if YesZakl>0 then begin
               Result:=Result+'<a name="'+NameZakl+'">';
            end;
         end;
         if strong>0 then begin
            Result:=Result+'<strong>';
         end;
         if italic>0 then begin
            Result:=Result+'<em>';
         end;

         Result:=Result+Sx;

         if strong>0 then begin
            Result:=Result+'</strong>';
         end;
         if italic>0 then begin
            Result:=Result+'</em>';
         end;

         if YesRef>0 then begin
            Result:=Result+'</a>';
         end
         else begin
            if YesZakl>0 then begin
               Result:=Result+'</a>';
            end;
         end;

         //    
         Result:=Result+'</td>';
         //-----------------------------------------

       end;

       //   
       Result:=Result+'</tr>';

    end;
 end;
end;


//******************************************************
function Query_CopyToHTML(Q : TQuery;
                          SelNameFields : TStrings;
                          Head : string;
                          AlignTable,BorderTable,SizeFontTopHead : integer;
                          ListOut : TStrings) : integer;
//   Q   HTML-
//Q -   
//SelNameFields -       Q
//Head - 
//AlignTable -  : <0-Left, =0-Center, >0-Right
//BorderTable -   
//SizeFontTopHead -     
//ListOut -  ( HTML-)

Var
  YesListFields,
  YesNext,
  YesRef,Align,i : integer;
  List2 : TStrings;
begin
  Result:=0;
  YesListFields:=0;

  ListOut.Clear;

  //-------------------------
  //,        Q
  if SelNameFields<>NIL then begin
     if SelNameFields.Count>0 then begin
        YesListFields:=1;
     end;
  end;
  //-------------------------

  //----------------------------------------------
  //  HTML-
  ListOut.Add(Create_TopHTML(Head,'Query_To_HTML','windows-1251','#FFFFFF',''));
  ListOut.Add(Create_StringForHTML('Date : '+DateTimeToStr(Now),'','','',-1,FALSE,FALSE,FALSE));
  ListOut.Add(Create_EmptyStringForHTML);
  ListOut.Add(Create_StringForHTML(Head,'','',IntToStr(SizeFontTopHead),0,TRUE,FALSE,TRUE));
  //----------------------------------------------

  List2:=TStringList.Create;
  TRY

    List2.Clear;


    //    HTML-
    ListOut.Add(Create_TopTable(AlignTable,BorderTable));

    { }

    Q.First;

    {  }
    for i:=0 to (Q.FieldCount-1) do
     begin

      YesNext:=0;
      if Q.Fields[i].Visible then begin
         YesNext:=1;
         if YesListFields>0 then begin
            //   .
            //,     
            YesNext:=0;
            if SelNameFields.IndexOf(Q.Fields[i].FieldName)>=0 then begin
               YesNext:=1;
            end;
         end;
      end;


      if YesNext>0 then begin
         List2.Add('0|1|0|0|0| | |'+Q.Fields[i].DisplayLabel);
      end;
    end;

    //   -   
    ListOut.Add(Create_LineTableHTML(List2));


    { }
    Q.First;
    while not Q.EOF do
     begin
      //Sx:='';

      List2.Clear;
      for i:=0 to (Q.FieldCount-1) do
       begin

        YesNext:=0;
        if Q.Fields[i].Visible then begin
           YesNext:=1;
           if YesListFields>0 then begin
              //   .
              //,     
              YesNext:=0;
              if SelNameFields.IndexOf(Q.Fields[i].FieldName)>=0 then begin
                 YesNext:=1;
              end;
           end;
        end;

        if YesNext>0 then begin

           YesRef:=0;
           Align:=-1;

           if Q.Fields[i].Alignment = taLeftJustify then begin
              Align:=-1;
           end;
           if Q.Fields[i].Alignment = taCenter then begin
              Align:=0;
           end;
           if Q.Fields[i].Alignment = taRightJustify then begin
              Align:=1;
           end;

           if POS(AnsiUpperCase('http://'),AnsiUpperCase(Q.Fields[i].AsString))>0 then begin
              //,     - HTTP-
              YesRef:=1;
           end;
           if POS(AnsiUpperCase('ftp://'),AnsiUpperCase(Q.Fields[i].AsString))>0 then begin
              //,     - FTP-
              YesRef:=1;
           end;
           if POS('@',Q.Fields[i].AsString)>0 then begin
              if POS('.',Q.Fields[i].AsString)>0 then begin
                 //,     -  
                 YesRef:=1;
              end;
           end;

           List2.Add(IntToStr(Align)+'|0|0|'+IntToStr(YesRef)+'|0| | |'+Q.Fields[i].AsString);

        end;
      end;

      //   
      ListOut.Add(Create_LineTableHTML(List2));

      Application.ProcessMessages;

      Q.Next;
    end;

    //     HTML-
    ListOut.Add(Create_BottomTable(AlignTable));

    //   HTML-
    ListOut.Add(Create_BottomHTML);


  FINALLY
    if List2<>NIL then begin
       List2.Clear;
       List2.Free;
       List2:=NIL;
    end;
  END;
end;
//******************************************************






//******************************************************
function CreateStandardAlias(NrAlwaysCreate: Boolean;
                             NameAlias,
                             Path,
                             DefDrv : String) : Boolean;
// Alias BDE-5 ()
//NrAlwaysCreate -  TRUE -   (  -  )
//NameAlias -  ()  Alias
//Path -    ()   
//DefDrv -   (  - PARADOX)
Var
   Sess : TSession;
   SList : TStrings;
   Sx : string;
   i : integer;
   Yes : byte;
begin
   Result:=FALSE;
   Yes:=0;
   NameAlias:=Trim(NameAlias);
   Path:=Trim(Path);
   DefDrv:=Trim(DefDrv);
   if Length(DefDrv)<=0 then DefDrv:='PARADOX';
   if (Length(NameAlias)>0) and (Length(Path)>0) and (Length(DefDrv)>0) then begin
      NameAlias:=AnsiUpperCase(NameAlias);
      Sess := TSession.Create(Nil);
      try
        Sess.SessionName:='~~!!SA!!~~';
        {Sess.Open;}
        SList := TStringList.Create;
        try
          Sess.GetAliasNames(SList);
          { fill a list box with alias names for the user to select from }
          i:=-1;
          while i<(SList.Count-1) do
           begin
             i:=i+1;
             Sx:=SList[i];
             Sx:=Trim(Sx);
             if Length(Sx)>0 then begin
                Sx:=AnsiUpperCase(Sx);
                if Sx=NameAlias then begin
                   Yes:=1;
                   if NrAlwaysCreate then begin
                      Yes:=0;
                      Sess.DeleteAlias(NameAlias);
                   end;
                   i:=SList.Count+1;
                end;
             end;
          end;
        finally
          SList.Free;
        end;
        if Yes<=0 then begin
           Sess.ConfigMode := cmAll;
           Sess.AddStandardAlias(NameAlias, Path,DefDrv);
           Sess.SaveConfigFile;
           Result:=TRUE;
        end;
      finally
        {Sess.Close;}
        Sess.Free;
      end;
   end;
end;
//******************************************************





end.





